> For the complete documentation index, see [llms.txt](https://developer.ultimo.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.ultimo.net/api-guide/soap/inserting-data.md).

# Inserting data

It is possible to change data by sending a request to one of the activated import connectors.

Each object to import should be bundled in a single \<object> node. All attributes of an object should be added as properties. The name of a property represents a database field in Ultimo. It is possible to send multiple objects at once. The action to execute per object should be determined when creating an interface.

It is also possible to nest objects, to create a parent/child construction. When nested objects are used, the ${Parent.Id} syntax can be used to refer to the parent. To make sure Ultimo tries to get the value of the parent, attribute Evaluation should be added.

*Example request including a nested object*

```javascript
<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:tem="http://tempuri.org/">
   <soapenv:Header/>
   <soapenv:Body>
      <tem:ImportData>
         <tem:importName>importconnector</tem:importName>
         <tem:userName>user</tem:userName>
         <tem:password>password</tem:password>
         <tem:importData><![CDATA[<Data>
        <Object Type="EntityName" Action="InsertOrUpdate">
                <Property Name="Id" Value="CODE01" />
                <Property Name="Description" Value="Object 1" />
        </Object>      

        <Object Type="EntityName" Action="InsertOrSkip">
                <Property Name="Id" Value="CODE02" />
                <Property Name="Description" Value="Object 2" />

                <Object Type="EntityName" Action="InsertOrSkip">
                        <Property Name="Id.Parent.Id" Value="${Parent.Id}" Evaluate="true" />
                        <Property Name="Id.Child" Value="CODE03" />
                        <Property Name="Description" Value="Nested object" />
                </Object>
        </Object>            
</Data>]]></tem:importData>
      </tem:ImportData>
   </soapenv:Body>
</soapenv:Envelope>
```

*Example response (returns the full request with the executed action per obejct or an exception)*

```javascript
<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">
    <s:Body>
        <ImportDataResponse xmlns="http://tempuri.org/">
            <ImportDataResult>
                <![CDATA[<?xml version="1.0" encoding="utf-16"?>
                <Data>
                    <Object Type="Equipment" Action="Insert">
                        <Property Name="Id" Value="CODE01" />
                    </Object>
                    <Object Type="Equipment" Action="Insert">
                        <Property Name="Id" Value="CODE02" />
                    </Object>
                    <Object Type="Equipment" Action="Insert">
                        <Property Name="Id" Value="CODE03" />
                    </Object>
                </Data>]]>
            </ImportDataResult>
        </ImportDataResponse>
    </s:Body>
</s:Envelope>
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developer.ultimo.net/api-guide/soap/inserting-data.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
